/*
 * tangoHokan - http://moto-mono.net/tangoHokan
 * jQuery Plugin. tested on 1.3.2
 *
 * Copyright 2009 (c) nori (norimania@gmail.com)
 * Licensed Under the MIT.
 *
 * $Date: 2009-06-01
*/

$.fn.tangoHokan = function(options){
	// オプション
	var c = $.extend({
		json: "data.json",
		//height: 150,
		top: 2,
		left: 0,
		noResult: "No word matched.",
		close: "Close"
	},options);
	
	// keyUp時に行う
	function keyUpMatching(elmApId,target){
		var val = target.val(), reg = new RegExp(val,"i");
		for(var i=0;i<$("li",elmApId).length;i++){
			var li = $("li",elmApId), text = $(li[i]).text();
			if(!text.match(reg)){
				$(li[i]).hide();
			}else{
				$(li[i]).show();
			}
		}
		if($("li:visible",elmApId).length==0){
			$("p.noresult").show();
		}else{
			$("p.noresult").hide();
		}
	}
	
	// 位置を決めて表示する - elmApId用
	$.fn.setPosAndShow = function(pos,self){
		$(this).css({
			position: "absolute",
			top: pos.top+self.attr("offsetHeight")+c.top,
			left: pos.left+c.left
		}).show();
		/*if(document.all && typeof document.body.style.maxHeight == "undefined"){
			if(c.height<$(this).height()) $(this).css("height",c.height);
		}else{
			$(this).css("maxHeight",c.height);
		}*/
	}
	
	$(this).each(function(){
		// よく使う変数
		var self = $(this),
			id = self.attr("id"),
			cl = "tangoHokan",
			apId = id+"_"+cl,
			elmApId = "#"+apId;
			
		// input.incSearchフォーカス時
		$(this).focus(function(){
			var pos = self.offset();
			$("div."+cl).hide();
			
			if($(elmApId) && $(elmApId).length>0){ // すでにelmApIdが生成されている場合
				$(elmApId).setPosAndShow(pos,self);
				keyUpMatching(elmApId,self);
			}else{ // ページロード後初めてselfをクリックした場合
				$("body").append("<div id='"+apId+"'></div>");
				$("span.close",elmApId).click(function(){ $(elmApId).hide(); });
				$(elmApId).addClass(cl).setPosAndShow(pos,self);
				$.getJSON(
					c.json, // 読み込むJSONデータのパス
					function(data){ // dataが受け取るJSONになる
						$(elmApId).append("<p class='noresult' style='display: none'>"+c.noResult+"</p><span class='close' title='"+c.close+"'>"+c.close+"</span><ul></ul>");
						for(var i=0;i<data[id].length;i++){
							// JSON[id]のデータを全て書き出す
							$("ul",elmApId).append("<li><a href='#'>"+data[id][i]+"</a></li>");
						}
						$("a",elmApId).click(function(){
							self.val($(this).text());
							$(elmApId).hide();
							return false;
						});
						$("span.close",elmApId).click(function(){
							$(elmApId).hide();
						});
					}
				);
			}
		}).keyup(function(){ // Up時にmatchingで評価
			keyUpMatching(elmApId,self);
		}).keypress(function(e){ // tab(9), esc(27)を押した場合は$(elmApId)を隠す
			if(e.keyCode==9 || e.keyCode==27) $(elmApId).hide();
		});
	});
}